<?php

/**
*  2018 iPay88 Indonesia
*
*  @author aldamustafri@ipay88.co.id
*  @copyright 2018 iPay88 Indonesia
*/

echo '<script type="text/javascript" src="//ajax.googleapis.com/ajax/libs/jquery/2.0.0/jquery.min.js"></script>';
 
class ipay88_credit_cardValidationModuleFrontController extends ModuleFrontController
{
	public function postProcess()
	{
		$cart = $this->context->cart;

		if ($cart->id_customer == 0 || $cart->id_address_delivery == 0 || $cart->id_address_invoice == 0 || !$this->module->active)
		Tools::redirect('index.php?controller=order&step=1');

		//Check that this payment option is still available in case the customer changed his address just before the end of the checkout process
		
		$authorized = false;
		
		foreach (Module::getPaymentModules() as $module)
		
		if ($module['name'] == 'ipay88_credit_card')
		{
			$authorized = true;
			break;
		}
			
		if (!$authorized)
			
		die($this->module->l('This payment method is not available.', 'validation'));

		$customer = new Customer($cart->id_customer);
	
		if (!Validate::isLoadedObject($customer))
			Tools::redirect('index.php?controller=order&step=1');

		$ipay88_credit_card 	= new ipay88_credit_card();
		$db 					= Db::getInstance();	
		$currency 				= new Currency((int)$cart->id_currency);
		
		//Product Desc
		//-1- $products = $order->getProducts();
        $products = $this->context->cart->getProducts(true);
		
		foreach ($products as $product) 
		{
			//-1- $data['prod_desc'][] = " ".$product['product_name']." x ".$product['product_quantity'].", ";
            $data['prod_desc'][] = " ".$product['name']." x ".$product['cart_quantity'].", ";
        }	

		$product_description = rtrim(implode($data['prod_desc']), ", ");
		
		
		//Create order list + update status payment pending
		$ipay88_credit_card->validateOrder($cart->id, Configuration::get('ipay88_credit_card_pending'), $cart->getOrderTotal(true, Cart::BOTH), $ipay88_credit_card->displayName, "iPay88 Payment Pending. iPay88 payment window page is being / has been ACCESSED. Quantity reduced for ".$product_description.".", NULL, (int)$currency->id, FALSE, $customer->secure_key);	
		
		$order = new Order($ipay88_credit_card->currentOrder);	
		
		
		//Payment ID
		$payment_id 	= $_POST['payment_id'];
		
		//Amount
		$total 			= $cart->getOrderTotal(true, Cart::BOTH);
		$orderAmount	= number_format($total, 2, ".", "");
	    $HashAmount 	= str_replace(".","",str_replace(",","",$orderAmount));	
		
		//Currency
		$currency_iso_code 	= $currency->iso_code;
		
		//User Contact
		$addressbilling = new Address(intval($cart->id_address_invoice));
		$user_contact 	= $addressbilling->phone;
		
		//Date
		date_default_timezone_set('Asia/Jakarta');	
		
		//Signature
		$MechantKey 	= Configuration::get('ipay88_credit_card_merchant_key');
		$MerchantCode 	= Configuration::get('ipay88_credit_card_merchant_code');
		$RefNo			= $order->id; 
		$Amount			= $HashAmount; 
		$Currency		= $currency_iso_code;
		$ipaySignature 	= "";
		
		$encrypt		= sha1($MechantKey.$MerchantCode.$RefNo.$Amount.$Currency);		
		
		for ($i=0; $i<strlen($encrypt); $i=$i+2)
		{
			$ipaySignature .= chr(hexdec(substr($encrypt,$i,2)));
		}
     	
		$ipaySignature = base64_encode($ipaySignature);
					
									
		//Response URL
		$responseurl 	= Tools::getShopDomainSsl(true).__PS_BASE_URI__.'module/ipay88_credit_card/response';
		
		//Backend URL
		$backendurl 	= Tools::getShopDomainSsl(true).__PS_BASE_URI__.'module/ipay88_credit_card/backend';
				
					
		$load_file_function = '
		<script language="JavaScript">
			$(document).ready(function() 
			{
				document.ipay88_request_paramaters.submit();
			});
		</script>';
		
		echo $load_file_function;
		
		$ipay88_request = array (
									'MerchantCode'	=> Configuration::get('ipay88_credit_card_merchant_code'),
									'PaymentId'		=> $payment_id,
									'RefNo' 		=> $order->id,
									'Amount' 		=> $HashAmount,
									'Currency'		=> $currency_iso_code,
									'ProdDesc' 		=> $product_description,
									'UserName' 		=> $customer->firstname.' '.$customer->lastname,
									'UserEmail' 	=> $customer->email,
									'UserContact' 	=> $user_contact,
									'Remark' 		=> "Transaction date ".date('Y-m-d H:i:s'),
									'Lang'			=> "UTF-8",
									'Signature'		=> $ipaySignature,
									'ResponseURL' 	=> $responseurl,
									'BackendURL'  	=> $backendurl,
								);
		
		$key = array_keys($ipay88_request);
				
		echo "<body>";
		echo "<form  name='ipay88_request_paramaters' ACTION='".Configuration::get('ipay88_credit_card_action')."' method='POST'>";

		for($i=0;$i<count($key);$i++) 
		{
			echo "<input type='hidden' name='".$key[$i]."' value='".$ipay88_request[$key[$i]]."' />";
		}
		
		echo "</form>";
				
		exit();
	}
	
}